/* pi_archimede.c 
   Funzione che calcola un'approssimazione di p_greco col metodo di 
   esaustione di Archimede.
  */
#include <math.h>
/* Scegli questi dati per partire col quadrato */
/*  #define NINIZ 4 */
/*  #define LISCR sqrt(2.) */
/*  #define LCSCR 2. */
/* Scegli questi dati per partire con l'esagono */
#define NINIZ 6
#define LISCR 1
#define LCSCR (2./sqrt(3.))
/*  */
double pi_archimede(err)
     double err;
{
  double p,q,delta;
  unsigned long n;
  n = NINIZ;
  p = n*LISCR;
  q = n*LCSCR;
  delta = .5*(q-p);
  while(delta>err) {
    q = 2.*q*p/(q+p);
    p = sqrt(q*p);
    delta = .5*(q-p);
  }
				/* Restituisci 1/4 del valore calcolato, che e' 2*pi */
  return(.25*(p+q));
}


